/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.io.Serializable;
import java.util.Comparator;

import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.dao.MSyozokuDao;
import jp.mosp.system.dto.MSyozokuDto;
import jp.mosp.system.vo.SyozokuMasterListVo;

public class SyozokuMasterListAction extends MosPAction {

	// コマンド
	private static final String CMD_SYOZOKU_LIST_SHOW       = "S2100";	// 表示
	private static final String CMD_SYOZOKU_LIST_SEARCH     = "S2101";	// 検索
	private static final String CMD_SYOZOKU_LIST_RE_SEARCH  = "S2102";	// 再検索
	private static final String CMD_SYOZOKU_TYPE_LIST_SORT  = "S2103";	// ソート

	/**
	 * コンストラクタ
	 */
	public SyozokuMasterListAction() {
		super();
	}

	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得
		SyozokuMasterListVo vo;
		Object obj = session.getAttribute(MospConst.ATT_FORMER_VO);
		if (obj instanceof SyozokuMasterListVo) {
			vo = (SyozokuMasterListVo) obj;
			vo.clearMessage();
			vo.clearErrField();
		} else {
			vo = new SyozokuMasterListVo();
		}
		vo.clearMessage();
		vo.clearErrField();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		session.setAttribute(MospConst.ATT_FORMER_VO, vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_SYOZOKU_LIST_SHOW)) {
			// 表示処理
			getConnection();
			// 検索履歴を初期値にセット	
			vo.setSearchmode(SyozokuMasterListVo.SEARCH_OFF);
		} else if (cmd.equals(CMD_SYOZOKU_LIST_SEARCH )) {
			// 検索処理
			vo.setParams(request);
			searchSyozokuMasterList(vo);
			vo.setFormerKey(vo.KEY_S_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
			// 検索履歴をありにセット
			vo.setSearchmode(SyozokuMasterListVo.SEARCH_ON);
		} else if (cmd.equals(CMD_SYOZOKU_LIST_RE_SEARCH)) {
			// 再検索
			if(vo.getSearchmode() == SyozokuMasterListVo.SEARCH_ON){
				session.removeAttribute(MospConst.ATT_DTO);
				searchSyozokuMasterList(vo);
				vo.setPageButton();
				sortList(vo);
			}			
		} else if (cmd.equals(CMD_SYOZOKU_TYPE_LIST_SORT)) {
			// ソート
			sortList(key1, vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 所属リスト検索
	 * @param vo CodeListVoインスタンス
	 * @throws Exception
	 */
	private void searchSyozokuMasterList(SyozokuMasterListVo vo) throws Exception {
		//DBコネクション取得
		getConnection();
		MSyozokuDao dao = new MSyozokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setFields(dao.findForCondition(vo.getTxtSCode(),vo.getTxtSName()));
		//対象がなかった場合のメッセージ設定
		if (vo.getEscArySCode().length == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}

	/**
	 * ソート
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(String key, SyozokuMasterListVo vo) throws MospException {
		vo.sortList(key, getComparator(key, vo));
		vo.setFields(vo.getList());
	}

	/**
	 * ソート(VO内のキー情報でソート)
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private void sortList(SyozokuMasterListVo vo) throws MospException {
		vo.sortList(getComparator(vo.getFormerKey(), vo));
		vo.setFields(vo.getList());
	}

	/**
	 * 比較クラス取得
	 * @param key ソートキー
	 * @param vo ソート対象Listを含むVO
	 * @throws MospException
	 */
	private Comparator getComparator(String key, SyozokuMasterListVo vo) throws MospException {
		Comparator comp = null;
		if (key.equals(vo.KEY_S_CODE)){
			comp = new CompSyozokuCode();
		} else if (key.equals(vo.KEY_S_NAME)) {
			comp = new CompSyozokuName();
		} else {
			throw new MospException(MospConst.EX_SORTKEY_INVALID);
		}
		return comp;
	}

	/**
	 * 所属コードによる比較クラス
	 */
	protected static class CompSyozokuCode implements Comparator, Serializable {
		private static final long serialVersionUID = -1583394950071248662L;
		public int compare(Object obj1, Object obj2) {
			MSyozokuDto dto1 = (MSyozokuDto)obj1;
			MSyozokuDto dto2 = (MSyozokuDto)obj2;
			return dto1.getSCode().compareTo(dto2.getSCode());
		}
	}

	/**
	 * 所属名による比較クラス
	 */
	protected static class CompSyozokuName implements Comparator, Serializable {
		private static final long serialVersionUID = -5375772027347639889L;
		public int compare(Object obj1, Object obj2) {
			MSyozokuDto dto1 = (MSyozokuDto)obj1;
			MSyozokuDto dto2 = (MSyozokuDto)obj2;
			return dto1.getSName().compareTo(dto2.getSName());
		}
	}

}
